package org.modcs.example;

import java.io.File;
import org.modcs.tools.parser.model.ExecutionRuntime;
import org.modcs.tools.parser.model.Model;
import org.modcs.tools.parser.model.Script;
import org.modcs.tools.parser.model.metrics.Metric;


public class EFMExample {
    public static void main(String[] args) {
        
        //creating the scripting evaluatin runtime
        ExecutionRuntime runtime = new ExecutionRuntime();
        
        //creating an evaluating the script, without
        //running the main block
        Script scrpt = new Script( new File("emf_model.mry"));        
        runtime.evaluateScript(scrpt);

        
        //modifying some variables and changing the model
        //parameters
        runtime.getVariableTable().setValue("mttf", 1000);
        runtime.getVariableTable().setValue("mttr", 1);
        runtime.getVariableTable().setValue("e", 0.8);
        runtime.getVariableTable().setValue("r", 5000);
        
        //obtaining reference to a model by passing
        //its identifier
        Model model = runtime.getModel("EFM1");
        
        //obtaining reference to a metric
        Metric m = model.getMetric("m2");
        
        //solving and printing the metric
        double val = m.solve();        
        System.out.println("Metric value: " + val);
        
        
        //performing a experiment
        double[] mttfs = { 500, 1000, 1500, 2000, 2500 };
        
        for(double mttf: mttfs){
            runtime.getVariableTable().setValue("mttf", mttf);
            
            System.out.println(m.solve());
        }
    }
}
